var PROGRESS_BAR_LOADED = false;

var soundManager = function(name, src){
	this.name = name;
	this.id = "#"+this.name;
	this.src = src;
	this.loaded = false;
	this.timePlaying = 0;
	this.volume = 1;
	this.volumeTime = [];
	this.volumeDrag = false;
	this.muteActive = false;
	this.autoplay = false;
	this.audioControls = {
		"mute": true,
		"volume": false,
		"progressbar": false,
		"stop": false,
		"rewind": false
	},
	this.playName = "play";
	this.pauseName = "pause";
	this.muteName = "mute";
	this.unmuteName = "unmute";
	this.stopName = "stop";
	this.rewindName = "rewind";
	this.hidden = false;
	this.popcorn = null;
	this.popcornEnabled = false;
};

$.extend(soundManager.prototype, {
	getSoundName: function(){
		return this.name;
	},
	getSoundId: function(){
		return this.id;
	},
	getSoundObj: function(){
		var response = this.getPopcorn();
		if(response === null){
		    if (!isiOS){
		    	response = $(this.getSoundId()).get(0);
			}
			else{
				response = $(this.getSoundId())[0];
			}
		}
		return response;
	},
	getSrc: function(){
		return this.src;
	},
	isPlaying: function(){
		var _paused = typeof this.getSoundObj().paused === "function" ? this.getSoundObj().paused() : this.getSoundObj().paused;
		return !_paused;
	},
	getTimePlaying: function(){
		return this.timePlaying;
	},
	getLoad: function(){
		return this.loaded;
	},
	getVolume: function(){
		return this.volume;
	},
	getVolumeTime: function(index){
		return this.volumeTime[index];
	},
	getVolumeDrag: function(){
		return this.volumeDrag;
	},
	getMuteActive: function(){
		return this.muteActive;
	},
	getAutoplay: function(){
		return this.autoplay;
	},
	getPlayName: function(){
		return this.playName;
	},
	getPauseName: function(){
		return this.pauseName;
	},
	getStopName: function(){
		return this.stopName;
	},
	getRewindName: function(){
		return this.rewindName;
	},
	getMuteName: function(){
		return this.muteName;
	},
	getUnmuteName: function(){
		return this.unmuteName;
	},
	getControlEnabled(control){
		return this.audioControls[control];
	},
	getPopcorn: function(){
		return this.popcorn;
	},
	isHidden: function(){
		return this.hidden;
	},
	isPopcorn: function(){
		return this.popcornEnabled;
	},
	setTimePlaying: function(value, update){
		this.timePlaying = value;

		if(update){
			var _soundObj = this.getSoundObj();
			if(typeof _soundObj.currentTime === "function"){
				_soundObj.currentTime(this.timePlaying);
			}else{
				_soundObj.currentTime = this.timePlaying;				
			}
		}
	},
	setLoad: function(value){
		this.loaded = value;
	},
	setVolume: function(value){
		this.volume = value;
		
		var _soundObj = this.getSoundObj();
		if(typeof _soundObj.volume === "function"){
			_soundObj.volume(this.volume);
		}else{
			_soundObj.volume = this.volume;			
		}
	},
	setVolumeTime: function(index, value){
		this.volumeTime[index] = value;
	},
	setVolumeDrag: function(value){
		this.volumeDrag = value;
	},
	setMuteActive: function(value){
		this.muteActive = value;
	},
	setAutoplay: function(value){
		this.autoplay = value;
	},
	setPlayName: function(value){
		this.playName = value;
	},
	setPauseName: function(value){
		this.pauseName = value;
	},
	setStopName: function(value){
		this.stopName = value;
	},
	setRewindName: function(value){
		this.rewindName = value;
	},
	setMuteName: function(value){
		this.muteName = value;
	},
	setUnmuteName: function(value){
		this.unmuteName = value;
	},
	setControlEnabled: function(control, value){
		this.audioControls[control] = value;
	},
	setPopcorn: function(){
		this.popcorn = Popcorn(this.getSoundId());
	},
	setHidden: function(value){
		this.hidden = value;
	},
	enablePopcorn: function(){
		this.popcornEnabled = true;
	},
	mute: function() {
		if(this.getLoad()){
			var _soundObj = this.getSoundObj();
			ims.interfaz.setTooltip(this.getMuteName(), ims.interfaz.getText("silenciar"));
			
	        //mute all sounds
	        var _volume = 0;
	        var _currentVolume = typeof _soundObj.volume === "function" ? _soundObj.volume() : _soundObj.volume;
console.log('mute', _soundObj);
	        $('.imsAudio').not(_soundObj).each(function(){
console.log('imsAudio', this);
	        	this.volume = _volume;
	        });
	        
			this.setVolumeTime(0, _currentVolume);
//			this.setVolumeTime(1, (parseInt(this.getVolumeTime(0) * 100) > 90) ? 90 : parseInt(this.getVolumeTime(0) * 100));
			
			this.setVolume(_volume);
			this.setMuteActive(true);
			this.toggleMuteButtons();
		}
	},
	unmute: function(){
		if(this.getLoad()){
			var _currentSound = this;
			var _soundObj = this.getSoundObj();
			ims.interfaz.setTooltip(this.getUnmuteName(), ims.interfaz.getText("silenciar"));
console.log('unmute', _currentSound.getVolumeTime(0));
	        //unmute all sounds
	        $('.imsAudio').not(_soundObj).each(function(){
	        	this.volume = _currentSound.getVolumeTime(0);
	        });
			
			this.setVolume(this.getVolumeTime(0));
			this.setMuteActive(false);
			this.toggleMuteButtons();
		}
	},
	toggleMuteButtons: function(){
	    if(this.getMuteActive()){
console.log('mute off');
	    	$("#"+this.getUnmuteName()).show();
	    	$("#"+this.getMuteName()).hide();
	    	ims.interfaz.disable(this.getMuteName());
	    	ims.interfaz.enable(this.getUnmuteName());
	    	ims.interfaz.disableSound();
	    }else{
console.log('mute on');
	    	$("#"+this.getUnmuteName()).hide();
	    	$("#"+this.getMuteName()).show();
	    	ims.interfaz.disable(this.getUnmuteName());
	    	ims.interfaz.enable(this.getMuteName());
	    	ims.interfaz.enableSound();
	    }
	},
	play: function() {
		var _currentSound = this;
		if(_currentSound.getLoad()){
			var _soundObj = _currentSound.getSoundObj();
			/*var overlay = $("<div>").attr("id", "hover");
			var hover_img = $("<div>").attr("id", "hover-image");
			
	        hover_img.removeAttr("style").remove();
	        overlay.removeAttr("style").remove();
	        hover_img.children().removeAttr("style").remove();
	        if ($(".rotate").length === 0) {
	            var a = $("<div/>").attr("id", "floatingCirclesG").addClass("rotate").append($("<div/>").attr("id", "frotateG_01").addClass("f_circleG")).append($("<div/>").attr("id", "frotateG_02").addClass("f_circleG")).append($("<div/>").attr("id", "frotateG_03").addClass("f_circleG")).append($("<div/>").attr("id", "frotateG_04").addClass("f_circleG")).append($("<div/>").attr("id", "frotateG_05").addClass("f_circleG")).append($("<div/>").attr("id", "frotateG_06").addClass("f_circleG")).append($("<div/>").attr("id", "frotateG_07").addClass("f_circleG")).append($("<div/>").attr("id", "frotateG_08").addClass("f_circleG"));
	            var b = $("#header").outerHeight(true) + ($("#visor").height() - $("#visor").height() * 0.15) / 2;
	            var c = ($("#visor").width() - $("#visor").width() * 0.15) / 2;
	            hover_img.css({
	                "top": b + "px",
	                "left": c + "px",
	                "position": "absolute",
	                "z-index": "999"
	            }).append(a);
	            overlay.css({
	                height: $("#limit").outerHeight(true) - $("#header").outerHeight(true),
	                top: $("#header").outerHeight(true)
	            });
	            $("#limit").append(overlay, hover_img)
	        }
			*/
			ims.interfaz.setTooltip(_currentSound.getPauseName(), ims.interfaz.getText("silenciar"));
		    ims.interfaz.enable(_currentSound.getMuteName());
		    ims.interfaz.enable(_currentSound.getPauseName());
		    $("#"+_currentSound.getPlayName()).hide();
		    $("#"+_currentSound.getPauseName()).show();
		    
		    _soundObj.on('timeupdate', function(){
		    	var _currentTime = typeof this.currentTime === "function" ? this.currentTime() : this.currentTime;
		    	var _duration = typeof this.duration === "function" ? this.duration() : this.duration;
console.log('currentTime', _currentSound.getTime(_currentTime)/*, 'duration', _currentSound.getTime(this.duration)*/);
				if(_currentSound.getControlEnabled("progressbar")){
					var _value = 0;
					if(_currentTime != _duration){
						_value = ~~(100 / _duration * _currentTime);
					}
console.log('progress', _currentTime);
					_currentSound.setTimePlaying(_currentTime, false);
		    	    $('#timer_'+_currentSound.getSoundName()).text(_currentSound.getTime(_currentSound.getTimePlaying()));
		    	    _currentSound.styleProgressBar(_value);
				}
				
				if(_currentTime == _duration){
					_currentSound.setTimePlaying(0, true);
					
					$("#"+_currentSound.getPlayName()).show();
					$("#"+_currentSound.getPauseName()).hide();
					
					if(typeof ims.actividad.onSoundStop === "function"){
						ims.actividad.onSoundStop();
					}
				}
	    	}, false);
		    
		    _soundObj.play();
		    ims.interfaz.enableSound();
		}
	},
	pause: function() {
		if(this.getLoad()){
			var _soundObj = this.getSoundObj();
			ims.interfaz.setTooltip(this.getPlayName(), ims.interfaz.getText("silenciar"));
		    ims.interfaz.enable(this.getPlayName());
		    $("#"+this.getPauseName()).hide();
		    $("#"+this.getPlayName()).show();
		    
			_soundObj.pause();	
		}
	},
	stop: function() {
		if(this.getLoad()){
		    this.pause();
		    this.setTimePlaying(0, true);

		    if(typeof ims.actividad.stopSound == "function"){
		    	ims.actividad.stopSound();
		    }			
		}
	},
	rewind: function(){
		if(this.getLoad()){
			this.setTimePlaying(0, true);	
		}
	},
	getTime: function(t) {
	    var m = ~~(t / 60), s = ~~(t % 60);
	    return (m < 10 ? "0" + m : m) + ':' + (s < 10 ? "0" + s : s);
	},
	setAudio: function(hidden){
	    // Sonido cancion
		var _currentSound = this;
		_currentSound.setHidden(hidden);
	    // Primer carga del audio y unica
	    if(_currentSound.getLoad() === false && _currentSound.getSoundName().length > 0) {
	        ims.interfaz.setSound(_currentSound.getSoundName(), ims.interfaz.getUrlFiles() + _currentSound.getSrc());
        	
	        if(_currentSound.isPopcorn()){
        		_currentSound.setPopcorn();
        	}
console.log('load', _currentSound, _currentSound.getSoundId());
	        _currentSound.getSoundObj().load();
	        
	        $(_currentSound.getSoundId()).on("loadeddata", function(e){
	        	_currentSound.setLoad(true);
	        	
	        	if(_currentSound.isPopcorn()){
console.log('isPopcorn');
	    			if(typeof ims.actividad.bindCue === "function"){
console.log('bindCue call', _currentSound);
	    		    	ims.actividad.bindCue(_currentSound);
	    		    }
	        	}
	        	
	        	//play
	        	_currentSound.setPlayName("play_"+_currentSound.getSoundName());
	        	ims.interfaz.addButton(_currentSound.getPlayName(), "left", "play", ims.interfaz.getText("play"));
	        	ims.interfaz.enable(_currentSound.getPlayName());
	        	
	        	//pause
	        	_currentSound.setPauseName("pause_"+_currentSound.getSoundName());
			    ims.interfaz.addButton(_currentSound.getPauseName(), "left", "pause", ims.interfaz.getText("pause"));
			    $("#"+_currentSound.getPauseName()).hide();
			    
			    //handlers
				$("#"+_currentSound.getPlayName()).click(function(){
					_currentSound.getSoundObj().play();
				});
				
				_currentSound.getSoundObj().on("play", function(){
					_currentSound.play();
				});
				
				$("#"+_currentSound.getPauseName()).click(function(){
					_currentSound.getSoundObj().pause();
				});
				
				_currentSound.getSoundObj().on("pause", function(){
					_currentSound.pause();
				});
		 		   
			    //Mute - unmute controls
			    if(!isMobile && _currentSound.getControlEnabled("mute")) {
			    	_currentSound.setMuteName("mute_"+_currentSound.getSoundName());
			    	_currentSound.setUnmuteName("unmute_"+_currentSound.getSoundName());
			    	
			        ims.interfaz.addButton(_currentSound.getMuteName(), "left", "silenciar", ims.interfaz.getText("silenciar"));
			        ims.interfaz.addButton(_currentSound.getUnmuteName(), "left", "silenciar_on", ims.interfaz.getText("silenciar"));
			        
			        _currentSound.toggleMuteButtons();			        	
		    	    
     	 		   $("#"+_currentSound.getMuteName()).click(function(){
     	 			 _currentSound.mute();
    			   });
     	 		   
//     	 		   _currentSound.getSoundObj().on("volumechange", function(){
//     	 			   if(this.volume === 0)
//     	 		   });
     	 		   
    	 		   $("#"+_currentSound.getUnmuteName()).click(function(){
    	 			   _currentSound.unmute();
    	 		   });
			    }

			    //stop control
			    if(!isMobile && _currentSound.getControlEnabled("stop")) {
			    	this.setStopName("stop_"+_currentSound.getSoundName());
			        ims.interfaz.addButton(_currentSound.getStopName(), "left", "rewind", ims.interfaz.getText("parar"));
			        ims.interfaz.enable(_currentSound.getStopName());
			        
        	    	$("#"+_currentSound.getStopName()).click(function(){
      	 			   _currentSound.getSoundObj().stop();
      	 		   });
        	    	
    				_currentSound.getSoundObj().on("stop", function(){
    					_currentSound.stop();
    				});
			    }
	    	    
	    	    //rewind control
	    	    if(_currentSound.getControlEnabled("rewind")){
	    	    	_currentSound.setRewindName("rewind_"+_currentSound.getSoundName());
	    	    	ims.interfaz.addButton(_currentSound.getRewindName(), "left", "rewind", ims.interfaz.getText("reiniciar"));
	    	    	ims.interfaz.enable(_currentSound.getRewindName());
	    	    	
        	    	$("#"+_currentSound.getRewindName()).click(function(){
      	 			   _currentSound.rewind();
        	    	});
	    	    }

	    	    $('#player_'+_currentSound.getSoundName()).remove();
	    	    $("#"+_currentSound.getPlayName()+", #"+_currentSound.getPauseName()+", #"+_currentSound.getMuteName()+", #"+_currentSound.getUnmuteName()+
	    	    		", #"+_currentSound.getStopName()+", #"+_currentSound.getRewindName()).wrapAll('<div id="player_'+_currentSound.getSoundName()+'" class="player-wrapper" />');
	    	    
	        	if(_currentSound.isHidden()){
	        		$("#player_"+_currentSound.getSoundName()).hide();
	        	}
	    	    
	    	    if(_currentSound.getControlEnabled("volume") || _currentSound.getControlEnabled("progressbar")){
	    	    	_currentSound.setProgressBars();
	    	    }
	    	    
			    //si esta activado autoplay iniciar la reproduccion
			    if(_currentSound.getAutoplay()){
			    	_currentSound.play();
			    }
			    
			    if(typeof ims.actividad.onAudioLoaded === "function"){
			    	ims.actividad.onAudioLoaded();
			    }
	        });
	    }
	},
	setProgressBars: function(){
		var _currentSound = this;
		if(!PROGRESS_BAR_LOADED){
			var _baseURL = getBaseUrl();
	    	
			link = document.createElement( "link" );
			link.href = _baseURL+"core/common/css/sound-manager.css";
			link.type = "text/css";	
			link.rel = "stylesheet";
			link.media = "screen";
			document.getElementsByTagName( "head" )[0].appendChild( link );
			
			requirejs( ["../core/common/js/jquery.ui.1.10.3"], function(){
				PROGRESS_BAR_LOADED = true;
				_currentSound.loadProgressBars();
			}, function( error ){
	console.log('fail loading jqueryui', error);
			});
		}else{
			_currentSound.loadProgressBars();
		}
	},
	styleProgressBar: function(value){
		$("#progressbar_"+this.getSoundName()).slider('value', value);
		$("#progressbar_"+this.getSoundName()).css({
			"background": "transparent linear-gradient(to right, #D7D7D7 0%, #59ACE9 0%, #59ACE9 "+value+"%, #D7D7D7 "+value+"%, #D7D7D7 100%) repeat scroll 0% 0%"			    			
		});
	},
	loadProgressBars: function(){
		this.setVolumeControlBar();
        this.setProgressControlBar();		
	},
	setVolumeControlBar: function(){
		var _currentSound = this;
		if(_currentSound.getControlEnabled("volume")){
			var volume   = $("<div/>").attr("id", "volumen_"+_currentSound.getSoundName()).attr("class", "volumen");
			var volumebar = $("<div/>").attr("id", "volumebar_"+_currentSound.getSoundName()).attr("class", "volumebar");

            $(volume).insertAfter('#'+_currentSound.getUnmuteName());
            $(volumebar).appendTo($(volume));
            
            $(volumebar).slider({
            	value : _currentSound.getVolume() * 100,
                slide : function(ev, ui) {
                	if(_currentSound.getMuteActive()){
                		return false;
                	}
                	_currentSound.setVolume(ui.value / 100);
                	_currentSound.styleVolumeControlBar();
                }
            });
            _currentSound.styleVolumeControlBar();
		}
	},
	styleVolumeControlBar: function(){
        $("#volumebar_"+this.getSoundName()).css({
    		"background": "transparent linear-gradient(to right, #D7D7D7 0%, #59ACE9 0%, #59ACE9 "+this.getVolume() * 100+"%, #D7D7D7 "+this.getVolume() * 100+"%, #D7D7D7 100%) repeat scroll 0% 0%"
    	});
	},
	setProgressControlBar: function(){
		var _currentSound = this;
		if(_currentSound.getControlEnabled("progressbar")) {
	    	var _soundObj = _currentSound.getSoundObj();
			
	        barra_str = "<div id='time_"+_currentSound.getSoundName()+"' class='time'><span id='timer_"+_currentSound.getSoundName()+"' class='timer'>00:00</span><div id='progressbar_"+_currentSound.getSoundName()+"' class='progressbar'>";
	        barra_str += "</div><span id='duration_"+_currentSound.getSoundName()+"' class='duration'></span></div>";
	        
	        if(ims.interfaz.getPositionBar()){
	        	$('#visor').append('<div id="pbr_'+_currentSound.getSoundName()+'" class="pbr"></div>');
	            
	        	$('#pbr_'+_currentSound.getSoundName()).css({
		            "position": "absolute",
		            "height": "20px",
		            "bottom": "65px",
		            "width": "100%",
		            "left": "35px",
		            "opacity": "0",
		            "filter": "alpha(opacity = 0)"
		        });
		        $("#pbr_"+_currentSound.getSoundName()).append(barra_str);
		        $('#time_'+_currentSound.getSoundName()).css('width', '91%');
		        
		        $("#visor_"+_currentSound.getSoundName()).click(function () {
	                $('#pbr_'+_currentSound.getSoundName()).css('opacity', '1');
	                setTimeout(function () {
	                    $('#pbr_'+_currentSound.getSoundName()).css('opacity', '1');
	                }, 5000);
		        });
	        }else{
	        	$("#player_"+_currentSound.getSoundName()).append(barra_str);
	        }			        

	        $("#progressbar_"+_currentSound.getSoundName()).slider({
	            value : _currentSound.getTimePlaying(),
	            slide : function(ev, ui) {
	            	var _duration = typeof _soundObj.duration === "function" ? _soundObj.duration() : _soundObj.duration;
	            	if(isNaN(_duration)){
	            		_duration = 0;
	            	}
	            	_currentSound.setTimePlaying(_duration / 100 * ui.value, true);
	            }
	          });

	        var _duration = typeof _soundObj.duration === "function" ? _soundObj.duration() : _soundObj.duration;
        	if(isNaN(_duration)){
        		_duration = 0;
        	}
	       $("#duration_"+_currentSound.getSoundName()).html(_currentSound.getTime(_duration));
	    }
	},
	hideAudio: function(){
		this.setHidden(true);
	    $("#player_"+this.getSoundName()).hide();
	},
	showAudio: function(){
		this.setHidden(false);
	    $("#player_"+this.getSoundName()).show();
	}
});
