function zoomManager(id, name, container){
	this.name = name;
	this.id = id;
	this.ratio = 1;
	this.minZoom = this.ratio;
	this.maxZoom = 4;
	this.zoomStep = 0.25;
	this.container = container;
	this.controls = {
		"zoomIn": true,
		"zoomOut": true,
		"zoomReset": true	
	};
}

zoomManager.prototype.init = function(){
	if (!isMobile){
		var _self = this;
		if(this.isControlEnabled("zoomReset")){
			ims.interfaz.addButton("resetZoom", "left", "resetZoom", ims.interfaz.getText("zoomreset") );
			ims.interfaz.enable("resetZoom");
			$("#resetZoom").click(function(){_self.funcResetZoom();});
		}
		if(this.isControlEnabled("zoomOut")){
			ims.interfaz.addButton("ZoomOut", "left", "zoomout", ims.interfaz.getText("zoomout"));
		}
		if(this.isControlEnabled("zoomIn")){
			ims.interfaz.addButton("ZoomIn", "left", "zoomin", ims.interfaz.getText("zoomin"));
			this.enableZoomIn();
		}
	}
	
	this.setRatio(this.getMinZoom());
	this.doZoom();
};
zoomManager.prototype.getName = function(){return this.name;};
zoomManager.prototype.getId = function(){return this.id;};
zoomManager.prototype.getRatio = function(){return this.ratio;};
zoomManager.prototype.getMinZoom = function(){return this.minZoom;};
zoomManager.prototype.getMaxZoom = function(){return this.maxZoom;};
zoomManager.prototype.getZoomStep = function(){return this.zoomStep;};
zoomManager.prototype.getContainer = function(){return this.container;};
zoomManager.prototype.isControlEnabled = function(control){return this.controls[control];};
zoomManager.prototype.setRatio = function(value){this.ratio = value;};
zoomManager.prototype.setMinZoom = function(value){this.minZoom = value;};
zoomManager.prototype.setMaxZoom = function(value){this.maxZoom = value;};
zoomManager.prototype.setControlEnabled = function(control, value){this.controls[control] = value};
zoomManager.prototype.toggleZoom = function(){
   if(this.getRatio() >= this.getMaxZoom()){
      this.disableZoomIn();
   }else if(this.getRatio() <= this.getMinZoom()){
      this.disableZoomOut();
   }else if(this.getRatio() <= this.getMaxZoom() && ! ($("#ZoomIn").hasClass( "notdisabled"))){
	   this.enableZoomIn();
   }else if(this.getRatio() >= this.getMinZoom() && ! $("#ZoomOut").hasClass("notdisabled")){
      this.enableZoomOut();
   }
};
zoomManager.prototype.zoomOut = function() {
	this.setRatio(this.getRatio() - this.getZoomStep());
	this.doZoom();
};
zoomManager.prototype.zoomIn = function() {
	this.setRatio(this.getRatio() + this.getZoomStep());
	this.doZoom();
};
zoomManager.prototype.enableZoomIn = function(){
    ims.interfaz.enable( "ZoomIn" );
    var _self = this;
    $("#ZoomIn").click(function(){_self.zoomIn();});
};
zoomManager.prototype.disableZoomIn = function(){
	ims.interfaz.disable( "ZoomIn" );
    $("#ZoomIn").unbind( "click" );
};
zoomManager.prototype.enableZoomOut = function(){
	ims.interfaz.enable("ZoomOut");
	var _self = this;
    $("#ZoomOut").click(function(){_self.zoomOut();});
};
zoomManager.prototype.disableZoomOut = function(){
	ims.interfaz.disable( "ZoomOut" );
    $( "#ZoomOut" ).unbind( "click" );
};
zoomManager.prototype.doZoom = function(){
	this.doScale(this.getContainer(), this.getRatio());
	this.toggleZoom();
};
zoomManager.prototype.doScale = function(item, zoom){
   $("#" + item).css({
	  "-moz-transform" : "scale(" + zoom + ")",
      "-webkit-transform" : "scale(" + zoom + ")",
      "-o-transform" : "scale(" + zoom + ")",
      "-ms-transform" : "scale(" + zoom + "," + zoom + ")",
      " transform" : "scale(" + zoom + ")",
   }
   , 500);
};
zoomManager.prototype.funcResetZoom = function(){
   if(this.getRatio() != this.getMinZoom()){
      this.setRatio(this.getMinZoom());

      this.doScale(this.getContainer(), this.getRatio());

      this.disableZoomOut();
      this.enableZoomIn();
   }
};