/*
 * SGO manda el JSON config_nrd y asume que existe un objeto nrd a la hora de
 * inicializar los recursos 3D.
 */
var nrd = {};
nrd.config = {};
nrd.config.baseUrl = '';

config_nrd = JSON.parse(config_nrd);
nrd.config.url = config_nrd.path;

// activities dictionary
var activities = {
    resaltar: {
        icon: 'bombilla',
        do: function(obj, event, capa) {
            // OBJ puede ser Array o String
            if (obj instanceof Array) {
                for (var i = 0; i < obj.length; i++)
                    highlight(obj[i], true);
                if (nrd.config.nrdJson.descriptions) {
                    if (!$('.descriptions').is(':visible') || event == 'click')
                        $('#description_' + obj[0]).show();
                    $('#resourceMenu').hide();
                }
            } else {
                highlight(obj, true);
                if (nrd.config.nrdJson.descriptions) {
                    if (!$('.descriptions').is(':visible') || event == 'click')
                        $('#description_' + obj).show();
                    $('#resourceMenu').hide();
                }
            }
        },
        undo: function(obj, event, capa) {
            // OBJ puede ser Array o String
            if (obj instanceof Array) {
                for (var i = 0; i < obj.length; i++)
                    highlight(obj[i], false);
                if (nrd.config.nrdJson.descriptions) {
                    $('#description_' + obj[0]).hide();
                    $('#resourceMenu').show();
                }
            } else {
                highlight(obj, false);
                if (nrd.config.nrdJson.descriptions) {
                    $('#description_' + obj).hide();
                    $('#resourceMenu').show();
                }
            }
        }
    },
    mostrar: {
        icon: 'ojo',
        do: function(obj, event) {
            if (obj instanceof Array) {
                for (var i = 0; i < obj.length; i++) {
                    hideOrShow(obj[i], false, event);
                    activities.descriptionImages.do(obj[i]);
                }
            } else {
                hideOrShow(obj, false, event);
                activities.descriptionImages.do(obj);
            }
        },
        undo: function(obj, event) {
            if (obj instanceof Array) {
                for (var i = 0; i < obj.length; i++) {
                    hideOrShow(obj[i], true, event);
                    activities.descriptionImages.undo(obj[i]);
                }
            } else {
                hideOrShow(obj, true, event);
                activities.descriptionImages.undo(obj);
            }
        }
    },
    ocultar: {
        icon: 'ojo',
        do: function(obj, event) {
            if (obj instanceof Array) {
                for (var i = 0; i < obj.length; i++) {
                    hideOrShow(obj[i], true, event);
                    activities.descriptionImages.do(obj[i]);
                }
            } else {
                hideOrShow(obj, true, event);
                activities.descriptionImages.do(obj);
            }
        },
        undo: function(obj, event) {
            if (obj instanceof Array) {
                for (var i = 0; i < obj.length; i++) {
                    hideOrShow(obj[i], false, event);
                    activities.descriptionImages.undo(obj[i]);
                }
            } else {
                hideOrShow(obj, false, event);
                activities.descriptionImages.undo(obj);
            }
        }
    },
    descriptionImages: {
        icon: 'ojo',
        do: function(obj, type, capa) {
            var id = obj instanceof Array ? obj[0] : obj;
            if (capa) {
                $('.descriptionImage').hide();
                $('.imageTitle').hide();
                $('.imageCaption').hide();
                $('#imageWrapper').show();
                $('#imageTitle_' + id).show();
                $('.separator').hide();

                // Mostrar separador si existe título.
                if (capa.imageTitle && capa.imageTitle.length) {
                    $('.separator').show();
                }

                $('#imageCaption_' + id).show();
                $('#image_' + id).show();
            }
        },
        undo: function(obj, type) {
            var id = obj instanceof Array ? obj[0] : obj;
            $('#imageWrapper').hide();
            $('#image_' + id).hide();
            $('.descriptionImage').hide();
            $('.imageTitle').hide();
            $('.imageCaption').hide();
            $('.separator').hide();
        }
    },
    multicamera: {
        icon: 'ojo',
        do: function(obj, type, capa) {
            $('#imageWrapper').hide();
            $('.descriptionImage').hide();
            $('.imageTitle').hide();
            $('.imageCaption').hide();
            if (obj instanceof Array) {
                if (type == 'click')
                moveCamera(obj, null, capa);
            } else {
                moveCamera(nrd.scene.getCameraByName(obj), null, capa);
            }
        },
        undo: function(obj, type, capa) {
            if (type == 'click') {
                if (obj instanceof Array) {
                    var list = obj.slice();
                    list.pop();
                    list.reverse().push(nrd.scene.getCameraByName('Camera_default').name);
                    moveCamera(list,null,capa);
                } else {
                    moveCamera(nrd.scene.getCameraByName('Camera_default'));
                }
            }
        }
    },
    descriptionImageAndHighlight: {
        icon: 'ojo',
        do: function(obj, type, capa) {
            activities.resaltar.do(obj, type, capa);
            activities.descriptionImages.do(obj, type, capa);
        },
        undo: function(obj, type, capa) {
            activities.resaltar.undo(obj, type, capa);
            activities.descriptionImages.undo(obj, type, capa);
        }
    },
    animation: {
        icon: 'ojo',
        do: function(obj, type, capa) {
            animate(capa.uid, true, capa);
        },
        undo: function(obj, type, capa) {
            animate(capa.uid, false, capa);
        }
    }
};

// Solución al error "mal formado" en Firefox.
$.ajaxSetup({'beforeSend': function(xhr) {
    if (xhr.overrideMimeType) {
        xhr.overrideMimeType('application/json');
    }
}});

// Para inicializar el recurso 3D es necesario llamar a initNRD y cargar el
// fichero nrd.json
$.getJSON(nrd.config.url + 'nrd.json', function(data) {
    nrd.config.nrdJson = data;
    initNRD();
});

// Carga del fichero nrd.json (metadatos del recurso 3D.
function loadNRD(id) {
    if(!BABYLON.Engine.isSupported()){
        var html = '<div id="errorWebGL"><h1>Hay un problema con la aceleraci&oacute;n 3D</h1>'  +
                   '<p>Lo sentimos, pero hay un problema con las opciones 3D de su dispositivo.' +
                   'Puede consultar la informaci&oacute;n disponible en la siguiente pagina '    +
                   'web <a href="https://get.webgl.org/">WebGL</a></p></div>';
        $('#visor').append(html);
    }
    var filename = id ? 'nrd_' + id : 'nrd';
    $.getJSON(nrd.config.url + filename + '.json', function(data) {
        if (!document.URL.match(/showheader=false/gi)) {
            if (!$('#headerText').length) {
                $('#visor').prepend($('<div>', { id: 'header' }));
                $('#header').append($('<div>', { id: 'headerText' }));
            }
            $('#headerText').html(config_nrd.textos.titulo);
        } else {
            $('#header').remove();
        }
        loadResource(id);
    });
}

// Cargador de recursos 3D.
function loadResource(id) {
    var canvas = $('#render')[0] ? $('#render')[0] : $('<canvas>', { id: 'render' })[0];
    var engine = new BABYLON.Engine(canvas, true);
    var file = id ?  'scene_' + id : 'scene';
    var loaderHTML = $('<div>', { class: 'initLoader', id: 'url_interfaz' });
    canvas.width = 1024;
    canvas.height = 517;
    $(canvas).appendTo('#visor');
    $('#visor').prepend(loaderHTML);
    BABYLON.SceneLoader.ShowLoadingScreen = false;
    BABYLON.SceneLoader.Load(nrd.config.url, file + '.babylon', engine, function(scene) {
        nrd.scene = scene;

        if (nrd.config.nrdJson.clearColor) {
            scene.clearColor = BABYLON.Color3.FromArray(nrd.config.nrdJson.clearColor);
        } else {
            scene.clearColor = new BABYLON.Color3(0.9, 0.9, 0.9);
        }

        scene.activeCamera = scene.getCameraByName('Camera_main');
        scene.activeCamera.target = new BABYLON.Vector3(0, 0, 0);
        scene.activeCamera.attachControl(canvas, false, false, true);
        scene.activeCamera.upperBetaLimit = nrd.config.nrdJson.upperBetaLimit;
        scene.activeCamera.lowerBetaLimit = nrd.config.nrdJson.lowerBetaLimit;
        scene.activeCamera.upperAlphaLimit = nrd.config.nrdJson.upperAlphaLimit;
        scene.activeCamera.lowerAlphaLimit = nrd.config.nrdJson.lowerAlphaLimit;
        scene.activeCamera.upperRadiusLimit = scene.getMeshByName('Locator_zoom_max').scaling.x;
        scene.activeCamera.lowerRadiusLimit = scene.getMeshByName('Locator_zoom_min').scaling.x;
        scene.activeCamera.panningSensibility = nrd.config.nrdJson.panningSensibility || 500;
        scene.activeCamera.wheelPrecision = nrd.config.nrdJson.wheelPrecision || 40;
        scene.activeCamera.pinchPrecision = nrd.config.nrdJson.pinchPrecision || 200;
        scene.activeCamera.pinchInwards = new BABYLON.Vector3(1, 1, 1);

        // Multiresource support
        if (nrd.config.nrdJson.multiResource) {
            multiResource(nrd.config.nrdJson.multiResource);
        }

        canvas.addEventListener('touchstart', function(event) {
            event.preventDefault();
        });

        canvas.addEventListener('mousedown', function(event) {
            canvas.classList.add('active');
        });

        canvas.addEventListener('mouseup', function(event) {
            canvas.classList.remove('active');
        });

        window.addEventListener('resize', function() {
            engine.resize();
        });

        if (nrd.config.nrdJson.audio) {
            loadAudio(nrd.config.nrdJson.audio);
        }

        engine.runRenderLoop(function() {
            scene.render();

            if (nrd.config.capas && nrd.config.nrdJson.hotspots) {
                resizeHotspots();
            }
        });

        $(loaderHTML).hide();
        scene.executeWhenReady(function() {
            if (nrd.config.nrdJson.enableWorkerCollision) {
                scene.workerCollisions = true;
            }

            loadCapas(id);

            if (/iPhone|iPad/gi.test(navigator.userAgent)) {
                canvas.width = 2048;
                canvas.height = 1034;
                engine.setHardwareScalingLevel(1);
            }

            if(/Android/.test(navigator.userAgent)){
                engine.setHardwareScalingLevel(zoomRatio);
                canvas.width = 1024;
                canvas.height = 517;
            }

            fixShadows();
        });
    });
}

// Carga el fichero capas.json que contiene las interacciones con el objeto 3D.
function loadCapas(id) {
    // Añade los elementos del DOM necesarios para el menú derecho.
    var container = $('<div>', { id: 'containerMenuContainer' });
    var menu = $('<div>', { id: 'menuContainer' });

    if (!$('#containerMenuContainer').length) {
        $('#content').append(container);
        $('#containerMenuContainer').append(menu);
    } else {
        $('#containerMenuContainer').replaceWith(container);
        $('#containerMenuContainer').append(menu);
    }
    $('#containerMenuContainer').hide();

    // Carga del fichero capas.json que contiene los elementos del menú derecho
    var filename = id ? 'capas_' + id : 'capas';
    var capas = $.getJSON(nrd.config.url + filename + '.json', function(data) {
        nrd.config.capas = data.capas;
        initHotspots();

        if (data) {
            var activity = data.tipoInteraccion;
            var defaultIcon = activities[activity].icon;

            // Funcionalidad menú derecho
            $('#verMenu').remove();
            $('#right').prepend($('<div>', {
                id: 'verMenu',
                class: 'boton right sprite tool ' + defaultIcon,
                title: 'menu'
            }));

            $('#verMenu').on('click', {}, function() {
                $('#verMenu').toggleClass('selected');
                if (!nrd.config.nrdJson.hotspots)
                    $('#containerMenuContainer').toggle();
                else
                    toggleHotspots();

                if ($('#verMenu').hasClass('selected')) {
                    $('#wrapper_descriptions').show();
                    $('#camera').trigger('click');
                } else {
                    if (nrd.config.nrdJson.hotspots) {
                        $('.botonMenu.clicked').trigger('click');
                        moveCamera(nrd.scene.getCameraByName('Camera_default'));
                    }
                    $('#wrapper_descriptions').hide();
                }
            });

            // Creación de botones del menú.
            for (var i = 0; i < data.capas.length; i++) {
                var capa = data.capas[i];
                var icon = capa.activity ? activities[capa.activity].icon : defaultIcon;
                var action = capa.activity ? capa.activity : activity;
                var boton = $('<div>', { id: 'botonMenu_' + i, class: 'botonMenu' })
                var text = $('<p>').append($('<a>', { class: 'sprite ' + icon }));
                var span = $('<span>', { html: data.capas[i].nombre });
                var obj = capa.uid;
                var animatables = data.capas[i].animatables;

                capa.activity = action;

                // Si hay capas bloqueadas, flag a true.
                if (capa.locked) { nrd.config.lockedHotspots = true; }

                $(boton).append($(text).append(span));
                $('#menuContainer').append(boton);

                // Añadir funcionalidad a cada uno de los botones.
                $('#botonMenu_' + i).on('mouseover', { object: obj, action: action, capa: capa }, function(event) {
                    if (!$(this).hasClass('selected')) {
                        $(this).addClass('selected');

                        if (!event.data.capa.onlyOnClick) {
                            activities[event.data.action].do(event.data.object, 'mouseover', event.data.capa);

                            if (event.data.capa.hideMeshes) {
                                event.data.capa.hideMeshes.forEach(function(element) {
                                    var mesh = nrd.scene.getMeshByName(element);
                                    if (mesh.isVisible) { mesh.isVisible = false; }
                                });
                            }

                            if (event.data.capa.showMeshes) {
                                event.data.capa.showMeshes.forEach(function(element) {
                                    var mesh = nrd.scene.getMeshByName(element);
                                    if (mesh.isVisible) { mesh.isVisible = true; }
                                });
                            }
                        }
                    }
                });

                $('#botonMenu_' + i).on('mouseout', { object: obj, action: action, capa: capa }, function(event) {
                    if (!$(this).hasClass('clicked')) {
                        $(this).removeClass('selected');
                        activities[event.data.action].undo(event.data.object, 'mouseout', event.data.capa);
                    }
                });

                $('#botonMenu_' + i).on('click', { object: obj, action: action, capa: capa }, function(event) {
                    var that = $(this);
                    var capa = event.data.capa;

                    if (nrd.config.nrdJson.seleccionUnica) {
                        $('.botonMenu.clicked').each(function(index, element) {
                            var id = element.id.replace(/botonMenu_/, '');
                            var capa = nrd.config.capas[id];

                            if (!capa.locked && (element.id != that.context.id)) {
                                $(element).removeClass('selected');
                                $(element).removeClass('clicked');

                                activities[nrd.config.capas[id].activity].undo(capa.uid, 'click', capa);

                                if (capa.hideMeshes) {
                                    capa.hideMeshes.forEach(function(element) {
                                        var mesh = nrd.scene.getMeshByName(element);
                                        if (!mesh.isVisible) { mesh.isVisible = true; }
                                    });
                                }

                                if (capa.showMeshes) {
                                    capa.showMeshes.forEach(function(element) {
                                        var mesh = nrd.scene.getMeshByName(element);
                                        if (mesh.isVisible) { mesh.isVisible = false; }
                                    });
                                }
                            }
                        });
                    }

                    that.toggleClass('clicked');

                    if ($(this).hasClass('clicked')) {
                        $(this).addClass('selected');

                        activities[event.data.action].do(event.data.object, 'click', capa);

                        if (capa.hideMeshes) {
                           capa.hideMeshes.forEach(function(element) {
                               var mesh = nrd.scene.getMeshByName(element);
                               if (mesh.isVisible) { mesh.isVisible = false; }
                           });
                        }

                        if (capa.showMeshes) {
                            capa.showMeshes.forEach(function(element) {
                                var mesh = nrd.scene.getMeshByName(element);
                                if (!mesh.isVisible) { mesh.isVisible = true; }
                            });
                        }
                    } else {
                        $(this).removeClass('selected');
                        $(this).removeClass('clicked');

                        activities[event.data.action].undo(event.data.object, 'click', capa);

                        if (capa.hideMeshes) {
                           capa.hideMeshes.forEach(function(element) {
                               var mesh = nrd.scene.getMeshByName(element);
                               if (!mesh.isVisible) { mesh.isVisible = true; }
                           });
                        }

                        if (capa.showMeshes) {
                            capa.showMeshes.forEach(function(element) {
                                var mesh = nrd.scene.getMeshByName(element);
                                if (mesh.isVisible) { mesh.isVisible = false; }
                            });
                        }
                    }
                });

                if (capa.clicked) {
                    var capa = nrd.config.capas[capa.id];
                    $('#botonMenu_' + i).addClass('clicked');
                    $('#botonMenu_' + i).addClass('selected');
                    activities[capa.activity].do(capa.uid, 'click', capa);
                }
            }
        }
    }).always(function() {
        setControls();
    });
}

// Establece cada uno de los botones del recurso.
function setControls() {
    var wheelDelta = nrd.config.nrdJson.wheelDelta || 100;
    if (!$('#zoomIn').length) {
        // Añadir botonera sólo si es un PC
        if (!isMobile) {
            addButton('zoomIn' , 'left', 'zoomin', 'zoom +');
            addButton('zoomOut', 'left', 'zoomout', 'zoom -');
            addButton('rotar', 'left', 'rotar', 'rotate');
            addButton('mover', 'left', 'mover', 'move');
        }

        // Vídeo support
        if (nrd.config.nrdJson.video) {
            $('#right').append($('<div>', { id: 'camera', class: 'boton right sprite camera' }));

            $('#camera').on('click', {}, function() {
                $('#camera').toggleClass('clicked');
                $('#camera').toggleClass('selected');
                if ($('#camera').hasClass('clicked')) {
                    $('video').addClass('minVideo');
                    $('video').removeClass('fillVideo');
                    $('#videoWrapper').show();
                    $('video').get(0).play();
                    if ($('#verMenu').hasClass('selected'))
                        $('#verMenu').trigger('click');
                } else {
                    $('#videoWrapper').hide();
                    $('video').get(0).pause();
                }
            });

            $('#render').before(
                $('<div>', { id: 'videoWrapper' })
                    .append($('<video>', { id: 'videoPlayer', controls: true })
                    .append(
                        $('<source>', { src: nrd.config.url + nrd.config.nrdJson.videoName, type: 'video/mp4' })
                    ))
            );
            $('#videoWrapper').hide();
            $('video').addClass('minVideo');

            $('video').on('ended', function(){
                $('#camera').removeClass('clicked');
                $('#camera').removeClass('selected');
                $('#videoWrapper').hide();
            });
        }

        // Animation support
        if (nrd.config.nrdJson.animation) {
            for (var i = 0; i < nrd.scene.meshes.length; i++) {
                nrd.scene.beginAnimation(nrd.scene.meshes[i], 0, nrd.config.nrdJson.animationFrames, true).pause();
            }

            $('#left').append($('<div>', { id: 'play', class: 'boton left sprite play' }));
            $('#play').on('click', {}, function() {
                $('#play').toggleClass('play');
                $('#play').toggleClass('pause');
                $('#play').toggleClass('clicked');
                $('#play').toggleClass('selected');

                if ($('#play').hasClass('clicked')) {
                    for (var i = 0; i < nrd.scene.Animatables.length; i++) {
                        nrd.scene.Animatables[i].restart();
                    }
                } else {
                    for (var i = 0; i < nrd.scene.Animatables.length; i++) {
                        nrd.scene.Animatables[i].pause();
                    }
                }
            });
        }

        // Descriptions support
        if (nrd.config.nrdJson.descriptions) {
            var wrapper = $('#wrapper_descriptions');
            if (!wrapper.length) {
                wrapper = $('<div>', {
                    id: 'wrapper_descriptions',
                    class: 'open'
                });

                $('#render').before(wrapper);
                for (var o in nrd.config.capas) {
                    var uid = nrd.config.capas[o].uid instanceof Array ?
                              nrd.config.capas[o].uid[0] : nrd.config.capas[o].uid;
                    var message = $('<div>', {
                        id: 'description_' +  uid,
                        class: 'descriptions',
                        html: nrd.config.capas[o].description
                    });
                    $('#wrapper_descriptions').append(message);
                    message.hide();
                }
            }
        }

        if (nrd.config.nrdJson.descriptionImages) {
            $('#render').before($('<div>', { id: 'imageWrapper' }));
            $('#imageWrapper').append($('<hr>', { class: 'separator' }));

            for (var i = 0; i < nrd.config.capas.length; i++) {
                var src = nrd.config.capas[i].image;
                var capa = nrd.config.capas[i];
                var name = capa.uid instanceof Array ? capa.uid[0] : capa.uid;
                $('.separator').before($('<h1>', {
                    class: 'imageTitle',
                    id: 'imageTitle_' + name,
                    html: nrd.config.capas[i].imageTitle
                }));

                $('#imageWrapper').append($('<p>', {
                    class: 'imageCaption',
                    id: 'imageCaption_' + name,
                    html: nrd.config.capas[i].imageCaption
                }));

                if (src) {
                    $('.imageCaption').before($('<img>', {
                        src: nrd.config.url + src,
                        id: 'image_' + name,
                        class: 'descriptionImage'
                    }));
                }

                $('#image_' + name).hide();
            }

            $('#imageWrapper').prepend($('<div>', { class: 'imageClose' }));
            $('#imageWrapper').hide();

            $('.imageClose').on('click', function() {
                var camera = nrd.scene.getCameraByName('Camera_default');

                for (var i = 0; i < nrd.config.capas.length; i++) {
                    var elm = $('#botonMenu_' + i);
                    if (elm.hasClass('clicked')) {
                        elm.trigger('click');
                        elm.removeClass('selected, clicked');
                    }
                }

                // Si hay hotspots bloqueados, oculta todos menos los bloqueados.
                if (nrd.config.nrdJson.lockedHotspots) { hideHotspots() };
                    moveCamera(camera);
            });
        }

        // Fullscreen support
        if (nrd.config.nrdJson.fullscreen && !isMobile) {
            $('#right').append($('<div>', { id: 'fullscreen', class: 'boton right sprite ampliar' }));
            $('#fullscreen').on('click', {}, function() {
                $('#render').get(0).width = screen.width;
                $('#render').get(0).height = screen.height;
                nrd.scene.getEngine().switchFullscreen();
            });
        }
        // Hotspots support
        if (nrd.config.nrdJson.hotspots) {
            $('#wrapper_descriptions').addClass('hotspots');
            $('#render').on('mousemove', function() {
                var pickResult = nrd.scene.pick(nrd.scene.pointerX, nrd.scene.pointerY).pickedMesh;
                if (pickResult && pickResult.name.match(/hotspot/i) && pickResult.visibility) {
                    $('#render').addClass('pointer');
                } else {
                    $('#render').removeClass('pointer');
                }
            });

            $('#render').on('click', pickHotspot);
            $('#render').on('touchend', pickHotspot);
        }

        if(nrd.config.nrdJson.reflection) {
			var mirror = nrd.scene.getMeshByName('Cube_map');
			var sphereCurtain = nrd.scene.getMeshByName('Sphere_curtain');
			if(nrd.config.nrdJson.reflectionMeshes instanceof Array){
				for (var meshes = 0; meshes < nrd.config.nrdJson.reflectionMeshes.length; meshes++) {
					var mesh = nrd.scene.getMeshByName(nrd.config.nrdJson.reflectionMeshes[meshes].reflectionMesh);

					sphereCurtain.diffuseColor = new BABYLON.Color3(0.9, 0.9, 0.9);

					mirror.material.reflectionTexture = new BABYLON.MirrorTexture("mirror", 1024, nrd.scene, true);
					mirror.material.reflectionTexture.mirrorPlane = new BABYLON.Plane(0, -1.0, 0, -2.0);
					mirror.material.reflectionTexture.renderList = [mesh];
					mirror.material.reflectionTexture.level = 1;

					// Main material
					var mainMaterial = new BABYLON.StandardMaterial("main", nrd.scene);
					mesh.material = mainMaterial;

					var probe = new BABYLON.ReflectionProbe("main", 512, nrd.scene);
					probe.renderList.push(mirror);
					mainMaterial.diffuseColor = new BABYLON.Color3(nrd.config.nrdJson.reflectionMeshes[meshes].reflectionColor.r,
																   nrd.config.nrdJson.reflectionMeshes[meshes].reflectionColor.g,
																   nrd.config.nrdJson.reflectionMeshes[meshes].reflectionColor.b);

					mainMaterial.reflectionTexture = probe.cubeTexture;
					mainMaterial.reflectionFresnelParameters = new BABYLON.FresnelParameters();
					mainMaterial.reflectionFresnelParameters.bias = nrd.config.nrdJson.reflectionMeshes[meshes].reflectionBias;
					mainMaterial.reflectionFresnelParameters.power = nrd.config.nrdJson.reflectionMeshes[meshes].reflectionPower;
				}
			} else {
				// Mirror
				var mesh = nrd.config.nrdJson.reflectionMesh || [];
				var meshes = [];
				if(Array.isArray(mesh)){
					for(var msh = 0; msh < mesh; msh++) {
						var objMesh = nrd.scene.getMeshByName(mesh[msh]);
						meshes.push[objMesh];
					}
				}
				sphereCurtain.diffuseColor = new BABYLON.Color3(0.9, 0.9, 0.9);

				mirror.material.reflectionTexture = new BABYLON.MirrorTexture("mirror", 1024, nrd.scene, true);
				mirror.material.reflectionTexture.mirrorPlane = new BABYLON.Plane(0, -1.0, 0, -2.0);
				mirror.material.reflectionTexture.renderList = meshes;
				mirror.material.reflectionTexture.level = 1;

				// Main material
				var mainMaterial = new BABYLON.StandardMaterial("main", nrd.scene);
				mesh.material = mainMaterial;

				var probe = new BABYLON.ReflectionProbe("main", 512, nrd.scene);
				probe.renderList.push(mirror);
				mainMaterial.diffuseColor = new BABYLON.Color3(nrd.config.nrdJson.reflectionColor.r,
															   nrd.config.nrdJson.reflectionColor.g,
															   nrd.config.nrdJson.reflectionColor.b);

				mainMaterial.reflectionTexture = probe.cubeTexture;
				mainMaterial.reflectionFresnelParameters = new BABYLON.FresnelParameters();
				mainMaterial.reflectionFresnelParameters.bias = nrd.config.nrdJson.reflectionBias;
				mainMaterial.reflectionFresnelParameters.power = nrd.config.nrdJson.reflectionPower;
			}
		}
        // Botón de reinicio
        $('#left').append($('<div>', { id: 'reiniciar', class: 'boton left sprite reiniciar' }));

        // Botón activado por defecto
        $('#rotar').addClass('selected');
        $('#rotar').addClass('clicked');


        // Añadir acciones a los botones
        $('#zoomIn').on('click', {}, function() {
            nrd.scene.activeCamera.wheelPrecision = wheelDelta;
            nrd.scene.activeCamera.radius -= nrd.scene.activeCamera.radius / nrd.scene.activeCamera.wheelPrecision;
        });

        $('#zoomOut').on('click', {}, function() {
            nrd.scene.activeCamera.wheelPrecision = wheelDelta;
            nrd.scene.activeCamera.radius = nrd.scene.activeCamera.radius + nrd.scene.activeCamera.radius / nrd.scene.activeCamera.wheelPrecision;
        });

        $('#rotar').on('click', {}, function() {
            var btnRotar = $('#rotar');
            var btnMove = $('#mover');
            var canvas = $('#render');

            if (btnRotar.hasClass('clicked')) {
                btnRotar.removeClass('clicked');
                btnRotar.removeClass('selected');
            } else {
                btnMove.removeClass('clicked');
                btnMove.removeClass('selected');
                btnRotar.addClass('clicked');
                btnRotar.addClass('selected');
                nrd.scene.activeCamera.inputs.attached['pointers']._isCtrlPushed = false;
            }
        });

        $('#mover').on('click', {}, function() {
            var btnMove = $('#mover');
            var btnRotar = $('#rotar');
            var canvas = $('#render');

            if (btnMove.hasClass('clicked')) {
                btnMove.removeClass('clicked');
                btnMove.removeClass('selected');
            } else {
                btnRotar.removeClass('clicked');
                btnRotar.removeClass('selected');
                btnMove.addClass('clicked');
                btnMove.addClass('selected');
                nrd.scene.activeCamera.inputs.attached['pointers']._isCtrlPushed = true;
            }
        });

        $('#reiniciar').on('click', {}, function() {
            $('.clicked').trigger('click');
            $('#rotar').trigger('click');
            $('#containerMenuContainer').hide();
            $('#wrapper_descriptions').hide();
            $('#verMenu').removeClass('clicked');
            $('#verMenu').removeClass('selected');

            if (nrd.config.nrdJson.animation) {
                for (var i = 0; i < nrd.scene.Animatables.length; i++) {
                    nrd.scene.Animatables[i].reset();
                    nrd.scene.Animatables[i].pause();
                    nrd.scene.Animatables[i].goToFrame(nrd.config.nrdJson.animationInitFrame);
                }
            }

            if (nrd.config.nrdJson.hotspots) { toggleHotspots(false); };

            var camera = nrd.scene.getCameraByName('Camera_default');
            moveCamera(camera);

            if (nrd.config.nrdJson.video) {
                $('video').get(0).pause();
                $('#videoWrapper').hide();
                $('#play').removeClass('selected');
                $('#play').removeClass('clicked');
                $('#play').removeClass('pause');
                $('#play').addClass('play');
            }
        });
    }
}

// Función de ayuda para las escenas multirrecurso.
function multiResource(src) {
    if (!$('#resourceMenu').length) {
        $('<div>', { id: 'resourceMenu' }).insertBefore('#render');
        for (var i = 0; i < src.length; i++) {
            var img = nrd.config.url + 'thumb' + i + '.jpg';
            var txt = nrd.config.nrdJson.multiResource[i];
            var dom = $('<img>', { id : 'resource_' + i, src: img, title: txt });
            var id  = i > 0 ? i : null;
            dom.appendTo('#resourceMenu');
            dom.on('click', { id: id }, function(event) {
                 loadNRD(event.data.id);
            });
        }
    }
}

// Función de ayuda para mover la cámara con animaciones.
function moveCamera(cameras, offset, capa) {
    var alphaAnim = new BABYLON.Animation('alphaAnim', 'alpha', 60, BABYLON.Animation.ANIMATIONTYPE_FLOAT, BABYLON.Animation.ANIMATIONLOOPMODE_CONSTANT);
    var betaAnim = new BABYLON.Animation('betaAnim', 'beta', 60, BABYLON.Animation.ANIMATIONTYPE_FLOAT, BABYLON.Animation.ANIMATIONLOOPMODE_CONSTANT);
    var radiusAnim = new BABYLON.Animation('radiusAnim', 'radius', 60, BABYLON.Animation.ANIMATIONTYPE_FLOAT, BABYLON.Animation.ANIMATIONLOOPMODE_CONSTANT);
    var targetAnim = new BABYLON.Animation('targetAnim', 'target', 60, BABYLON.Animation.ANIMATIONTYPE_VECTOR3, BABYLON.Animation.ANIMATIONLOOPMODE_CONSTANT);
    var offset = offset || 0;
    var camera = cameras;
    var animatables = capa ? capa.animatables || [] : [];

    if (cameras instanceof Array)
        camera = nrd.scene.getCameraByName(cameras[offset]);
    else
        var camera = cameras;

    // Recalculate alpha value.
    var rad = 6.28319;
    var calc = Math.floor(nrd.scene.activeCamera.alpha / rad);

    if (nrd.scene.activeCamera.alpha > rad) {
        nrd.scene.activeCamera.alpha -= rad * calc;
    } else if (nrd.scene.activeCamera.alpha < -rad / 2) {
        nrd.scene.activeCamera.alpha += rad * Math.abs(calc);
    }

    if (camera == null) return;
    alphaAnim.setKeys([{ frame: 0, value: nrd.scene.activeCamera.alpha }, { frame: 100, value: camera.alpha }]);
    betaAnim.setKeys([{ frame: 0, value: nrd.scene.activeCamera.beta }, { frame: 100, value: camera.beta }]);
    radiusAnim.setKeys([{ frame: 0, value: nrd.scene.activeCamera.radius }, { frame: 100, value: camera.radius }]);
    targetAnim.setKeys([{ frame: 0, value: nrd.scene.activeCamera.target }, { frame: 100, value: camera.lockedTarget.position }]);

    // Configure new camera limits
    if (camera.lockedTarget && camera.lockedTarget.name.match(/locator_(.*)/gi)) {
        var locator = camera.lockedTarget.name.replace(/_min|_max/gi, '');
        nrd.scene.activeCamera.lowerRadiusLimit = nrd.scene.getMeshByName(locator + '_min').scaling.x;
        nrd.scene.activeCamera.upperRadiusLimit = nrd.scene.getMeshByName(locator + '_max').scaling.x;
    }

    // Animate objects when the camera start to move.
    if (animatables.length) {
        for (var a = 0; a < animatables.length; a++)
            nrd.scene.beginAnimation(nrd.scene.getMeshByName(animatables[a].name), 0, animatables[a].frames, false, 1);
    }

    nrd.scene.activeCamera.animations = [];
    nrd.scene.activeCamera.animations.push(alphaAnim);
    nrd.scene.activeCamera.animations.push(betaAnim);
    nrd.scene.activeCamera.animations.push(radiusAnim);
    nrd.scene.activeCamera.animations.push(targetAnim);

    function next() {
        if (cameras[++offset])
            moveCamera(cameras, offset);
    }

    nrd.scene.beginAnimation(nrd.scene.activeCamera, 0, 100, false, 1, next);
}

// Función de para resaltar un objeto. el parámetro restore tiene que ser true
// si se debe activar el parpadeo, false si no.
function highlight(name, restore) {
    var mesh = nrd.scene.getMeshByName(name);
    if (mesh) {
        var animationExists = false;

        for (var a = 0; a < mesh.animations.length; a++) {
            if (mesh.animations[a].name == 'highlight_' + mesh.name)
                animationExists = true;
        }

        if (!animationExists) {
            var anim = new BABYLON.Animation('highlight_' + mesh.name, 'overlayAlpha', 60, BABYLON.Animation.ANIMATIONTYPE_FLOAT, BABYLON.Animation.ANIMATIONLOOPMODE_CYCLE);
            nrd.config.currentAnimation = anim;

            anim.setKeys([
                { frame: 10, value: 0.0 },
                { frame: 60, value: 0.5 },
                { frame: 90, value: 0.0 }
            ]);

            mesh.overlayColor = new BABYLON.Color3(0.8, 0, 0.5413);
            mesh.animations.push(anim);
        }

        mesh.renderOverlay = restore;
        nrd.scene.beginDirectAnimation(mesh, [mesh.getAnimationByName('highlight_' + mesh.name)], 0, 90, true);
    }
}

// Función de ayuda para ocultar o mostrar un objeto.
function hideOrShow(meshes, hide, event) {
    var mesh = nrd.scene.getMeshByName(meshes);

    if (mesh) {
        if (!nrd.config.nrdJson.hotspots) {
            mesh.isVisible = !hide;
        } else {
            var animationExists = false;
            var start = hide ? 60 : 0;
            var end = hide ? 90 : 60;

            for (var a = 0; a < mesh.animations.length; a++) {
                if (mesh.animations[a].name == 'hideOrShow_' + mesh.name) {
                    animationExists = true;
                }
            }

            if (!animationExists) {
                var anim = new BABYLON.Animation('hideOrShow_' + mesh.name, 'visibility', 60, BABYLON.Animation.ANIMATIONTYPE_FLOAT, BABYLON.Animation.ANIMATIONLOOPMODE_CYCLE);
                nrd.config.currentAnimation = anim;
                anim.setKeys([{ frame: 0, value: 0.0 }, { frame: 60, value: 1.0 }, { frame: 90, value: 0.0 }]);
                mesh.animations.push(anim);
            }

            // Esto es para mejorar la interactividad con los hotspots cuando el mesh se oculta.
            if (!hide) { mesh.isVisible = true; }

            nrd.scene.beginDirectAnimation(mesh, [mesh.getAnimationByName('hideOrShow_' + mesh.name)], start, end, false, 1, function() {
                if (hide) { mesh.isVisible = false; }
            });
        }
    }
}

// Inicialización de Hotspots
function initHotspots() {
    for (var i = 0; i < nrd.config.capas.length; i++) {
        var capa = nrd.config.capas[i];
        var name = capa.uid instanceof Array ? capa.uid[0] : capa.uid;
        var mesh = nrd.scene.getMeshByName('Hotspot_' + name);
        if (mesh) {
            nrd.config.capas[mesh.name] = nrd.config.capas[i];
            mesh.billboardMode = BABYLON.AbstractMesh.BILLBOARDMODE_ALL;
            mesh.material.backFaceCulling = false;
            mesh.visibility = false;
        }
    };
}

function pickHotspot() {
    var pickResult = nrd.scene.pick(nrd.scene.pointerX, nrd.scene.pointerY).pickedMesh;
    if (pickResult && pickResult.name.match(/hotspot/i) && pickResult.visibility) {
        var capa = nrd.config.capas[pickResult.name];
        var obj = capa.uid instanceof Array ? capa.uid[0] : capa.uid;
        var picked = $('#botonMenu_' + nrd.config.capas[pickResult.name].id);
        if (nrd.config.capas[pickResult.name].activeHotspots instanceof Array) {
            hideHotspots();
        }
        var cameras = false;
        if (nrd.config.capas[pickResult.name].cameras) {
            cameras = nrd.config.capas[pickResult.name].cameras;
        }
        picked.trigger('click');
        if (picked.hasClass('clicked')) {
            if (nrd.config.capas[pickResult.name].activeHotspots instanceof Array) {
                for (var hspot = 0; hspot < nrd.config.capas[pickResult.name].activeHotspots.length; hspot++) {
                    nrd.scene.getMeshByName("Hotspot_" + nrd.config.capas[pickResult.name].activeHotspots[hspot]).visibility = true;
                }
            }
            if (cameras) {
                moveCamera(cameras, null, nrd.config.capas[pickResult.name].id);
            } else {
                var camera = nrd.scene.getCameraByName(pickResult.name.replace(/hotspot_/i, 'Camera_'));
            }
            moveCamera(camera);

        } else {
            if (nrd.config.capas[pickResult.name].activeHotspots instanceof Array) {
                for (var hspot = 0; hspot < nrd.config.capas[pickResult.name].activeHotspots.length; hspot++) {
                    nrd.scene.getMeshByName("Hotspot_" + nrd.config.capas[pickResult.name].activeHotspots[hspot]).visibility = false;
                }
            }
            if (cameras) {
                var list = cameras.slice();
                list.pop();
                list.reverse().push(nrd.scene.getCameraByName('Camera_default').name);
                moveCamera(list,null,nrd.config.capas[pickResult.name].id);
            } else {
                if (nrd.config.capas[pickResult.name].resetTo) {
                    var camera = nrd.scene.getCameraByName('Camera_' + nrd.config.capas[pickResult.name].resetTo);
                } else {
                    var camera = nrd.scene.getCameraByName('Camera_default');
                }
                moveCamera(camera);
            }
        }
    }
}

function toggleHotspots(value) {
    for (var i = 0; i < nrd.config.capas.length; i++) {
        var capa = nrd.config.capas[i];
        var name = capa.uid instanceof Array ? capa.uid[0] : capa.uid;
        var mesh = nrd.scene.getMeshByName('Hotspot_' + name);

        if (mesh) {
            mesh.visibility = mesh.visibility ? false : true;
            mesh.visibility = value !== undefined ? value : mesh.visibility;

            if (nrd.config.capas[i].dependHotspot) {
                mesh.visibility = false;
            }
        }
    }
}

function hideHotspots() {
    for (var i = 0; i < nrd.config.capas.length; i++) {
        var capa = nrd.config.capas[i];
        var name = capa.uid instanceof Array ? capa.uid[0] : capa.uid;
        var mesh = nrd.scene.getMeshByName('Hotspot_' + capa.uid);
        if (mesh && !capa.locked && capa.dependHotspot) { mesh.visibility = false; }
    }
}

function resizeHotspots() {
    var factor = /Android|iPhone|iPad/gi.test(navigator.userAgent) ? 0.03 : 0.02;
    for (var i = 0; i < nrd.config.capas.length; i++) {
        var uids = nrd.config.capas[i].uid;
        var name = uids instanceof Array ? uids[0] : uids;
        var mesh = nrd.scene.getMeshByName('Hotspot_' + name);
        var camera = nrd.scene.activeCamera;
        var distance = BABYLON.Vector3.Distance(camera.position, mesh.position);
        mesh.scaling.x = distance * factor;
        mesh.scaling.y = distance * factor;
        mesh.scaling.z = distance * factor;
    }
}

function loadAudio(audio) {
    for (var aud = 0; aud < audio.length; aud++)
        new BABYLON.Sound('audio' + aud, nrd.config.url + audio[aud].source, nrd.scene, null, audio[aud].options);
}

// Las sombras tienen un funcionamiento distinto en iOS y Android. Esta función
// sirve para ajustarlas según el dispositivo.
function fixShadows() {
    for (var i = 0; i < nrd.scene.lights.length; i++) {
        shadowGenerator = nrd.scene.lights[i].getShadowGenerator();
        if (shadowGenerator) {
            // Reducir la calidad de las sombras en móviles y tablets.
            shadowGenerator.usePoissonSampling = false;

            // Custom bias para Android e iOS.
            if (nrd.config.nrdJson.androidBias && /Android/gi.test(navigator.userAgent))
                shadowGenerator.bias = nrd.config.nrdJson.androidBias;
            if (nrd.config.nrdJson.iOSBias && /iPhone|iPad/gi.test(navigator.userAgent))
                shadowGenerator._bias = nrd.config.nrdJson.iOSBias;
        }
    }
}

//Función para controlar las animaciones desde el pick de los hotspots
function animate(uid, value, capa) {
    var initAnimation;
    var endAnimation;

    if (capa.animate == 'all') {
        if (capa.animationKeys) {
            initAnimation = value ? capa.animationKeys.init : capa.animationKeys.end + 1;
            endAnimation = value ? capa.animationKeys.end : capa.animationKeys.reverse;
            for (var a = 0; a < nrd.scene.meshes.length; a++) {
                nrd.scene.beginAnimation(nrd.scene.meshes[a], initAnimation , endAnimation, false , 1);
            }
        }
    }
}